my_tribune=$tribune[Thread.current[:name]]
my_post=my_tribune.current_post
my_module=my_tribune.current_mod
my_conf=my_module.config

###############################################################################
#                                 PREUMS                                      #
###############################################################################

if my_module.params[:time] == nil
  if my_conf.elements["time"] == nil
    my_module.params[:time] = "00:00:00"
  else
    my_module.params[:time] = my_conf.elements["time"].text
  end
end

if my_module.params[:strict] == nil
  if my_conf.elements["strict"] == nil
    my_module.params[:strict] = 0
  else
    my_module.params[:strict] = my_conf.elements["strict"].text.to_i
  end
end

if my_module.params[:jours] == nil
  if my_conf.elements["jours"] == nil
    my_module.params[:jours] = Array.new(7, true)
  else
    my_module.params[:jours] = Array.new()
    my_conf.elements["jours"].text.split(",").each{|i| my_module.params[:jours][i.to_i]=true}
  end
end

if my_module.params[:preums_name] == nil
  my_module.params[:preums_name] = my_module.nom.split("$")[1]
  if my_module.params[:preums_name].nil?
    my_module.params[:preums_name] = ""
  end
end

##on récupère la date du dernier preumsage dans la table preums_msg, et on détermine la date du prochain preumsage.
##C'est un peu tiré par les cheveux (domi<?), mais je n'ai rien trouvé d'autre:
##Si le jour même, à l'heure du preums, est dans le futur, alors c'est bon
##Si c'est dans le passé (ça inclut s'il est 00:00:00², qui est après 00:00:00¹), on prend le lendemain
##Si la table est vide, on met la dernière date au 1er janvier 1970
if my_module.params[:prochain_preums] == nil
  dern_date = dbh("select_one","SELECT DATE_FORMAT(post_time,'%Y%m%d') AS time FROM #{my_tribune.db_prefix}preums_msg WHERE preums_name = ?", my_module.params[:preums_name]).to_s
  if dern_date == ""
    dern_date = my_post.date
  end
  
  my_module.params[:prochain_preums] = dern_date + my_module.params[:time].gsub(":","")
  if my_module.params[:prochain_preums] < my_post.timestamp || ( my_module.params[:prochain_preums] == my_post.timestamp && my_post.doublon > 1 )
    my_module.params[:prochain_preums] = Time.parse(my_module.params[:prochain_preums] + " +0000").utc.+(24*3600).strftime("%Y%m%d%H%M%S")
  ##on passe par l'UTC, sinon ça pose un problème avec les changements d'heure, et on convertit en string 'timestamp' pour faire une comparaison sans se prendre la tête avec le décalage horaire
  
  ##si le preum's n'a lieu que certains jours, on s'assure que la date du prochain preum's sera un de ces jours
  while my_module.params[:jours][Time.parse(my_module.params[:prochain_preums] + " +0000").wday] != true
    my_module.params[:prochain_preums] = Time.parse(my_module.params[:prochain_preums] + " +0000").utc.+(24*3600).strftime("%Y%m%d%H%M%S")
  end
  end
end

##ici, on s'occupe du preumsage: si le timestamp est supérieur ou égal à my_module.params[:prochain_preums] alors c'est un preum's (et si c'est un jour de preums)
if my_post.timestamp >= my_module.params[:prochain_preums]

  if my_post.nhorloge == my_module.params[:time]
    is_strict = true
  else
    is_strict = false
  end
  
  if my_post.login == ""
    is_anon = true
  else
    is_anon = false
  end

  


  ##on recharge la configuration (pour les "multis" et les belles dates)
  multi = my_conf.elements["multis/#{my_post.login}"] if not is_anon
  bonjour = my_conf.elements["bonjours/#{my_post.date[4..7]}"]


  ##on supprime l'ancien message du preumseur, et on met le nouveau à la place

  ##si "strict" vaut 2, les anonymes ne sont autorisés à voler un preums aux moules authentifiées que s'il est strict
  if not ( my_module.params[:strict] == 2 and is_strict == false and is_anon == true )
    dbh("do","DELETE FROM #{my_tribune.db_prefix}preums_msg WHERE preums_name = ?", my_module.params[:preums_name])
    dbh("do","INSERT INTO #{my_tribune.db_prefix}preums_msg (post_id, post_time, login, info, message, preums_name) VALUES (?,?,?,?,?,?)", my_post.post_id, my_post.timestamp, my_post.login, my_post.ua, my_post.message, my_module.params[:preums_name])

    my_module.params[:prochain_preums] = my_post.date + my_module.params[:time].gsub(":","")
    if my_module.params[:prochain_preums] <= my_post.timestamp
      my_module.params[:prochain_preums] = Time.parse(my_module.params[:prochain_preums] + " +0000").utc.+(24*3600).strftime("%Y%m%d%H%M%S")
    end
    ##si le preum's n'a lieu que certains jours, on s'assure que la date du prochain preum's sera un de ces jours
    while my_module.params[:jours][Time.parse(my_module.params[:prochain_preums] + " +0000").wday] != true
      my_module.params[:prochain_preums] = Time.parse(my_module.params[:prochain_preums] + " +0000").utc.+(24*3600).strftime("%Y%m%d%H%M%S")
    end
#    log("debug: preums$" + my_module.params[:preums_name].to_s + " prochain_preums " + my_module.params[:prochain_preums].to_s)
  end

  ##Si c'était un preums strict et que le message n'étais pas à l'heure, on dit au posteur qu'il a raté, et on ne lui donne pas de points
  if (is_strict || my_module.params[:strict] != 1) && is_anon == false
    ##on ajoute 1 à son score dans la table (ou on le créé s'il n'existe pas)
    dbh("do","INSERT INTO #{my_tribune.db_prefix}preums (login,score,preums_name) VALUES (?,?,?) ON DUPLICATE KEY UPDATE score=score+1 ", my_post.login, 1, my_module.params[:preums_name])


    ##on poste un message de félicitation au preumseur (ça permet de conserver notre cookie)
    ##avec un message spécial pour certains jours de l'année
    ##un petit mot pour certaines moules
    ##et le classement du preumseur

    rang = dbh("select_one", "SELECT COUNT(*) + 1 FROM #{my_tribune.db_prefix}preums a INNER JOIN #{my_tribune.db_prefix}preums b ON b.login = ? WHERE a.preums_name = ? AND b.preums_name = ? AND a.score > b.score AND NOT EXISTS (SELECT login FROM #{my_tribune.db_prefix}blacklist WHERE #{my_module.nom} = 1 AND a.login = #{my_tribune.db_prefix}blacklist.login ) ", my_post.login, my_module.params[:preums_name], my_module.params[:preums_name])[0]

    case rang
    when 1
      classement = "premier"
    when 2
      classement = "deuxième"
    else
      classement = rang.to_s + "ème"
    end
  end

  if bonjour != nil
    bonjour = bonjour.attributes["msg"]
  else
    bonjour = my_conf.elements["bonjours/default"]
    if bonjour != nil
      bonjour = bonjour.attributes["msg"]
    else
      bonjour = "Bonjour"
    end
  end

  if multi != nil
    moule = multi.attributes["name"]
  elsif is_anon == true
    moule = "moule anonyme (<i>" + my_post.ua + "</i>)"
  else
    moule = my_post.login
  end

  if is_strict
    if is_anon
      if my_module.params[:strict] == 2
        log("Une moule anonyme (" + my_post.ua + ") a preumsé (voleur) à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Dommage que tu ne sois pas authentifié [:kiki]. Tu as quand même volé un preums, j'espère que tu es fier de toi !")
      else
        log("Une moule anonyme (" + my_post.ua + ") a preumsé à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Dommage que tu ne sois pas authentifié [:kiki].")
      end
    else
      log(my_post.login + " a preumsé à " + my_post.nhorloge + ". Message: " + my_post.message)
      envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Tu es " + classement + " ! " + my_tribune.webroot + "preums.rhtml?preums_name=" + my_module.params[:preums_name])
    end
  else
    if is_anon
      if my_module.params[:strict] == 2
        log("Une moule anonyme (" + my_post.ua + ") a raté le preums (strict pour les anonymes) de " + my_module.params[:time] + " à " + my_post.nhorloge + ". Message: " + my_post.message)
#        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Tu as raté : il fallait poster à " + my_module.params[:time] + " tout pile...(Les moules authentifiées ont le droit de poster en retard [:kiki].)")
      elsif my_module.params[:strict] == 0
        log("Une moule anonyme (" + my_post.ua + ") a preumsé à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Dommage que tu ne sois pas authentifié [:kiki].")
      else
        log("Une moule anonyme (" + my_post.ua + ") a raté le preums (strict) de " + my_module.params[:time] + " à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Tu as raté : il fallait poster à " + my_module.params[:time] + " tout pile... Mais de toutes façons il faut être authentifié [:kiki].")
      end


    else
      if my_module.params[:strict] == 1
        log(my_post.login + " a raté le preums (strict) de " + my_module.params[:time] + " à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Tu as raté : il fallait poster à " + my_module.params[:time] + " tout pile... Je suis sur que tu feras mieux la prochaine fois")
      else
        log(my_post.login + " a preumsé à " + my_post.nhorloge + ". Message: " + my_post.message)
        envoi(my_tribune, my_post.nhorloge2 + " " +  bonjour + " " + moule + ". Tu es " + classement + " ! " + my_tribune.webroot + "preums.rhtml?preums_name=" + my_module.params[:preums_name])
      end

    end
  end



end ##fin de la gestion des preums
